property mcurpage, mitemlist, mrow, mcolumn, mcurline, mpos, mleft, mtop, minterval, mindex, mtopspritenum, mflag

on new me, itemlist, id, col, row, left, top, topspritenum
  me.mpos = 0
  me.mcurpage = 0
  me.mcurline = 0
  me.mitemlist = itemlist
  me.mcolumn = col
  me.mrow = row
  me.mleft = left
  me.mtop = top
  me.minterval = 24
  me.mtopspritenum = topspritenum
  me.mflag = 0
  pos = -1
  repeat with i = 1 to mitemlist.count
    if id = me.mitemlist[i].id then
      pos = i
    else
    end if
  end repeat
  if pos = -1 then
    me.mindex = -1
  else
    me.mindex = pos - 1
  end if
  me._update()
  return me
end

on delete me
  repeat with i in me.mitemlist
  end repeat
  sendAllSprites(#clear)
end

on length me, str
  len = 0
  repeat with i = 1 to str.length
    if charToNum(char i of str) > 255 then
      len = len + 2
    else
      len = len + 1
    end if
  end repeat
  return len
end

on update me, msg
  maxlength = 32
  repeat with i in msg
    pos = searchchatroom(me, i.roomid)
    if pos = 0 then
      me.mitemlist.add(i)
      newfield = new(#field)
      newfield.name = "label" & i.roomid
      newfield.forecolor = 255
      newfield.backcolor = 18
      str = i.name
      repeat while me.length(str) < maxlength
        str = str & "."
      end repeat
      newfield.text = str & i.member & "人"
      newfield.font = "ＭＳ ゴシック"
      newfield.fontSize = 12
      rect = newfield.rect
      rect.right = 232
      newfield.rect = rect
      me.minterval = newfield.lineHeight
    else
      str = i.name
      repeat while me.length(str) < maxlength
        str = str & "."
      end repeat
      member("label" & i.roomid).text = str & i.member & "人"
    end if
  end repeat
  me._update()
end

on searchchatroom me, roomid
  pos = 0
  repeat with i = 1 to me.count(#mitemlist)
    if me.mitemlist[i].roomid = roomid then
      pos = i
    else
    end if
  end repeat
  return pos
end

on _update me
  sendAllSprites(#clear)
  repeat with i = 0 to mrow - 1
    repeat with j = 0 to mcolumn - 1
      pos = me.mpos + me.mcolumn * i + j
      if pos < me.count(#mitemlist) then
        new(script("チャットルームリスト"), pos, me.mitemlist[pos + 1], mtopspritenum + me.mcolumn * i + j, me.mleft, me.mtop + me.minterval * i)
      end if
    end repeat
  end repeat
  sendAllSprites(#_select, mindex)
end

on scrollByLine me, amount
  pos = me.mcolumn * me.mcurline + amount
  if me.mcolumn = 1 then
    m = me.mcolumn * me.mrow
  else
    m = me.mcolumn * me.mrow - 1
  end if
  if pos >= 0 and pos <= me.count(#mitemlist) - m then
    me.mcurline = me.mcurline + amount
    me.mpos = pos
  end if
  me._update()
end

on select me, index
  me.mindex = index
end

on getselectid me
  if me.mindex <> -1 then
    return me.mitemlist[me.mindex + 1].roomid
  end if
end

on resize me
  if me.mflag then
    h = the stageBottom - the stageTop
    me.mrow = h - 80 / me.minterval - 1
    me._update()
  else
    me.mflag = 1
  end if
end
