on offsetrect r
  desttoprect = the deskTopRectList[1]
  stagecenterh = desttoprect.right - desttoprect.left / 2
  stagecenterv = desttoprect.bottom - desttoprect.top / 2
  width = r.right - r.left
  height = r.bottom - r.top
  left = stagecenterh - width / 2
  top = stagecenterv - height / 2
  right = left + width
  bottom = top + height
  return rect(left, top, right, bottom)
end

on replace str, substr1, substr2
  pos = offset(substr1, str)
  len = substr1.length - 1
  repeat while pos
    delete char pos to pos + len of str
    str1 = char 1 to pos - 1 of str
    str2 = char pos to str.length of str
    if str2 = "" then
      str = str1
    else
      str = str1 & substr2 & str2
    end if
    pos = offset(substr1, str)
  end repeat
  return str
end

on xor a, b
  return not a and b and a or b
end

on xor2 a, b
  r = 0
  repeat with i = 7 down to 0
    p = integer(power(2, i))
    r = r + xor(a / p, b / p) * p
    a = a mod p
    b = b mod p
  end repeat
  return r
end

on highbyte inword
  return inword / 256
end

on lowbyte inword
  return inword mod 256
end

on numtohex num
  num1 = num / 16
  num2 = num mod 16
  case num1 of
    10:
      num1 = "A"
    11:
      num1 = "B"
    12:
      num1 = "C"
    13:
      num1 = "D"
    14:
      num1 = "E"
    15:
      num1 = "F"
    otherwise:
      num1 = string(num1)
  end case
  case num2 of
    10:
      num2 = "A"
    11:
      num2 = "B"
    12:
      num2 = "C"
    13:
      num2 = "D"
    14:
      num2 = "E"
    15:
      num2 = "F"
    otherwise:
      num2 = string(num2)
  end case
  return num1 & num2
end

on hextonum hex
  if length(hex) = 2 then
    hex1 = char 1 of hex
    hex2 = char 2 of hex
  else
    hex1 = ""
    hex2 = hex
  end if
  case hex1 of
    "A":
      hex1 = 10
    "B":
      hex1 = 11
    "C":
      hex1 = 12
    "D":
      hex1 = 13
    "E":
      hex1 = 14
    "F":
      hex1 = 15
    otherwise:
      hex1 = integer(hex1)
  end case
  case hex2 of
    "A":
      hex2 = 10
    "B":
      hex2 = 11
    "C":
      hex2 = 12
    "D":
      hex2 = 13
    "E":
      hex2 = 14
    "F":
      hex2 = 15
    otherwise:
      hex2 = integer(hex2)
  end case
  return hex1 * 16 + hex2
end

on encodeurl inurl
  badlist = [" ", "<", ">", QUOTE, "{", "}", "|", "¥", "^", "[", "]", "'"]
  outurl = ""
  repeat with i = 1 to the number of chars in inurl
    tchar = char i of inurl
    tchar2 = ""
    tnum = charToNum(tchar)
    if tnum > 255 then
      tchar = "%" & numtohex(highbyte(tnum))
      tchar2 = "%" & numtohex(lowbyte(tnum))
    else
      if getOne(badlist, tchar) or tnum < 32 or tnum = 127 then
        tchar = "%" & numtohex(tnum)
      else
      end if
    end if
    outurl = outurl & tchar & tchar2
  end repeat
  return outurl
end

on minimum
  if the stageLeft = -32000 and the stageRight = -32000 then
    return 1
  else
    return 0
  end if
end

on equal str, str2
  ret = 1
  if str.length = str2.length then
    repeat with i = 1 to str.length
      if charToNum(char i of str) <> charToNum(char i of str2) then
        ret = 0
      else
      end if
    end repeat
  else
    ret = 0
  end if
  return ret
end

on stringtonum str
  ret = ""
  repeat with i = 1 to str.length
    ret = ret & charToNum(char i of str)
  end repeat
  return ret
end
