property mfriendlist
global gconnection

on new me
  me.initialize()
  return me
end

on initialize me
  me.mfriendlist = []
end

on openWindow me
  if windowPresent("friend") then
    window("friend").visible = 1
  else
    window("friend").fileName = the moviePath & "data¥friend.dir"
    window("friend").windowType = 0
    window("friend").title = "トモダチリスト"
    window("friend").rect = offsetrect(window("friend").rect)
    window("friend").visible = 1
  end if
end

on getstatus me, userid
  pos = searchmember(me, userid)
  if pos.folder and pos.member then
    member = me.mfriendlist[pos.folder].member
    return member[pos.member]
  end if
end

on getfolder me, folderid
  pos = me.searchfolder(folderid)
  if pos then
    return me.mfriendlist[pos]
  end if
end

on getfoldername me, folderid
  folder = me.getfolder(folderid)
  if not voidp(folder) then
    return folder.name
  end if
end

on searchfolder me, folderid
  pos = 0
  repeat with i = 1 to me.count(#mfriendlist)
    folder = me.mfriendlist[i]
    if folder.folderid = folderid then
      pos = i
    else
    end if
  end repeat
  return pos
end

on searchmember me, userid
  plist = [#folder: 0, #member: 0]
  repeat with i = 1 to me.count(#mfriendlist)
    member = me.mfriendlist[i].member
    repeat with j = 1 to member.count
      items = member[j]
      if equal(items.userid, userid) then
        plist.setaProp(#folder, i)
        plist.setaProp(#member, j)
        return plist
      end if
    end repeat
  end repeat
  return plist
end

on receivefolder me, msg
  pos = searchfolder(me, msg.folderid)
  if pos = 0 then
    msg.addProp(#member, [])
    me.mfriendlist.add(msg)
  else
    me.mfriendlist[pos].name = msg.name
  end if
  if windowPresent("friend") then
    tell window("friend")
      sendAllSprites(#setfolder, msg)
    end tell
  end if
end

on receivestatus me, msg, folderid
  pos = searchmember(me, msg.userid)
  if pos.folder <> 0 and pos.member <> 0 then
    member = me.mfriendlist[pos.folder].member
    member[pos.member] = msg
    msg2 = duplicate(msg)
    msg2.addProp(#folderid, me.mfriendlist[pos.folder].folderid)
    if windowPresent("friend") then
      tell window("friend")
        sendAllSprites(#setstatus, msg2)
      end tell
    end if
  else
    if not voidp(folderid) then
      me.addstatus(msg, folderid)
    end if
  end if
end

on addstatus me, msg, folderid
  pos = searchfolder(me, folderid)
  if pos then
    me.mfriendlist[pos].member.add(msg)
    msg2 = duplicate(msg)
    msg2.addProp(#folderid, folderid)
    if windowPresent("friend") then
      tell window("friend")
        sendAllSprites(#setstatus, msg2)
      end tell
    end if
  else
    me.receivestatus(msg, folderid)
  end if
end

on receiveerror me, msg
  if windowPresent("friend") then
    tell window("friend")
      sendAllSprites(#error)
    end tell
  end if
end

on sendfriend me, msg
  case msg.option of
    #rmv:
      me._rmvfriend(msg)
    #renum:
      me._renumfriend(msg)
    #move:
      me._movefriend(msg)
  end case
  if windowPresent("friend") then
    tell window("friend")
      sendAllSprites(#success)
    end tell
  end if
end

on sendfolder me, msg
  case msg.option of
    #rmv:
      me._rmvfolder(msg)
    #renum:
      me._renumfolder(msg)
    #rename:
      me._renamefolder(msg)
  end case
  if windowPresent("friend") then
    tell window("friend")
      sendAllSprites(#success)
    end tell
  end if
end

on _rmvfriend me, msg
  pos = searchmember(me, msg.userid)
  if pos.folder and pos.member then
    me.mfriendlist[pos.folder].member.deleteAt(pos.member)
    if windowPresent("friend") then
      tell window("friend")
        sendAllSprites(#deletestatus, msg)
      end tell
    end if
  end if
end

on _renumfriend me, msg
  pos = me.searchfolder(msg.folderid)
  if pos then
    tmplist = []
    repeat with userid in msg.member
      tmplist.add(me.getstatus(userid))
    end repeat
    me.mfriendlist[pos].member = tmplist
    if windowPresent("friend") then
      tell window("friend")
        sendAllSprites(#renumfriend, msg)
      end tell
    end if
  end if
end

on _movefriend me, msg
  srcpos = me.searchfolder(msg.src)
  destpos = me.searchfolder(msg.dest)
  if srcpos and destpos then
    pos = me.searchmember(msg.userid)
    if pos.folder = srcpos and pos.member then
      me.mfriendlist[destpos].member.add(me.getstatus(msg.userid))
      me.mfriendlist[srcpos].member.deleteAt(pos.member)
    end if
    if windowPresent("friend") then
      tell window("friend")
        sendAllSprites(#movefriend, msg)
      end tell
    end if
  end if
end

on _rmvfolder me, msg
  pos = me.searchfolder(msg.folderid)
  if pos then
    me.mfriendlist.deleteAt(pos)
    if windowPresent("friend") then
      tell window("friend")
        sendAllSprites(#deletefolder, msg)
      end tell
    end if
  end if
end

on _renumfolder me, msg
  tmplist = []
  repeat with folderid in msg.member
    tmplist.add(me.getfolder(folderid))
  end repeat
  me.mfriendlist = tmplist
  if windowPresent("friend") then
    tell window("friend")
      sendAllSprites(#renumfolder, msg)
    end tell
  end if
end

on _renamefolder me, msg
  pos = me.searchfolder(msg.folderid)
  if pos then
    me.mfriendlist[pos].name = msg.name
  end if
  if windowPresent("friend") then
    tell window("friend")
      sendAllSprites(#setfolder, msg)
    end tell
  end if
end

on _showfolder me, msg
  if windowPresent("friend") then
    tell window("friend")
      sendAllSprites(#success)
    end tell
  end if
end

on test me
  sendAllSprites(#showstatus, "トモダチ情報の取得中...")
  repeat with folder in me.mfriendlist
    gconnection.send("friend list" && string(folder.folderid))
  end repeat
end

on receivedenied me, msg
  me._rmvfriend(msg)
end

on updatefolder me, msg
  call(#del, the actorList)
  pos = me.searchfolder(msg)
  if pos then
    the actorList.add(new(script("フォルダの更新"), me.mfriendlist[pos].member, msg))
  end if
end
