property mpref, misfirstlogin, mmodified

on new me
  me.getpreference()
  me.misfirstlogin = 1
  me.mmodified = 0
  return me
end

on setpreference me
  me.mpref.deleteProp(#status)
  me.mpref.left = the stageLeft
  me.mpref.top = the stageTop
  if not me.mpref.savepassword then
    me.mpref.password = ""
  end if
  password = me.mpref.password
  me.mpref.password = me.codec(me.mpref.password)
  me.save()
  me.mpref.password = password
end

on getpreference me
  if me.load() then
    if the runMode = "Projector" then
      width = the stageRight - the stageLeft
      height = the stageBottom - the stageTop
      the stage.rect = rect(me.mpref.left, me.mpref.top, me.mpref.left + width, me.mpref.top + height)
    end if
    me.mpref.password = me.codec(me.mpref.password)
  else
    me.mpref = [#userid: "", #password: "", #savepassword: 0, #left: 0, #top: 0, #skin: the moviePath & "skins¥default.cst"]
  end if
  me.mpref.addProp(#status, [#userid: "", #charid: 0, #emotionid: 0, #boomid: 0, #emotion: "", #boom: "", #connect: 0])
end

on load me
  path = the moviePath & "loopit.ini"
  file = new(xtra("fileio"))
  if objectp(file) then
    openfile(file, path, 1)
    if error(file, status(file)) <> "OK" then
      file = 0
      return 0
    end if
    str = readfile(file)
    closefile(file)
    me.mpref = value(str)
    if not listp(me.mpref) then
      file = 0
      return 0
    end if
    file = 0
    return 1
  end if
  return 0
end

on save me
  path = the moviePath & "loopit.ini"
  file = new(xtra("fileio"))
  if objectp(file) then
    openfile(file, path, 2)
    if error(file, status(file)) = "OK" then
      delete(file)
    end if
    createfile(file, path)
    if error(file, status(file)) <> "OK" then
      file = 0
      return 0
    end if
    openfile(file, path, 2)
    if error(file, status(file)) <> "OK" then
      file = 0
      return 0
    end if
    writestring(file, string(me.mpref))
    closefile(file)
    file = 0
    return 1
  end if
  return 0
end

on getuserid me
  return me.mpref.userid
end

on setuserid me, userid
  me.mpref.userid = userid
end

on getpassword me
  return me.mpref.password
end

on setpassword me, password
  me.mpref.password = password
end

on setsavepassword me, flag
  me.mpref.savepassword = flag
end

on getsavepassword me
  return me.mpref.savepassword
end

on getcharid me
  return me.mpref.status.charid
end

on initstatus me, msg
  me.misfirstlogin = 1
  me.mpref.status = msg
  sendAllSprites(#setstatus, me.mpref.status)
  sendAllSprites(#setuserid, me.mpref.status.userid)
  sendAllSprites(#setemotionstring, me.mpref.status.emotion)
  sendAllSprites(#setemotioniconname, me.mpref.status.emotionid)
  sendAllSprites(#setemotionicon, me.mpref.status.emotionid)
  sendAllSprites(#setboomstring, me.mpref.status.boom)
  sendAllSprites(#setboomiconname, me.mpref.status.boomid)
  sendAllSprites(#setboomicon, me.mpref.status.boomid)
end

on receivestatus me, msg
  if equal(me.mpref.userid, msg.userid) then
    me.mpref.status = msg
    sendAllSprites(#setstatus, me.mpref.status)
    sendAllSprites(#setuserid, me.mpref.status.userid)
    sendAllSprites(#setemotionstring, me.mpref.status.emotion)
    sendAllSprites(#setemotioniconname, me.mpref.status.emotionid)
    sendAllSprites(#setemotionicon, me.mpref.status.emotionid)
    sendAllSprites(#setboomstring, me.mpref.status.boom)
    sendAllSprites(#setboomiconname, me.mpref.status.boomid)
    sendAllSprites(#setboomicon, me.mpref.status.boomid)
  end if
end

on disconnect me
  sendAllSprites(#setconnect, 0)
  sendAllSprites(#init)
end

on getfirstlogin me
  return me.misfirstlogin
end

on sendemotion me, msg
  me.mpref.status.setaProp(#emotionid, msg.emotionid)
  me.mpref.status.setaProp(#emotion, msg.emotion)
end

on sendboom me, msg
  me.mpref.status.setaProp(#boomid, msg.boomid)
  me.mpref.status.setaProp(#boom, msg.boom)
end

on getstatus me
  return me.mpref.status
end

on codec me, str
  tmp = ""
  repeat with i = 1 to length(str)
    c = charToNum(char i of str)
    if c > 255 then
      tmp = tmp & numToChar(xor2(123, highbyte(c)))
      tmp = tmp & numToChar(xor2(123, lowbyte(c)))
    else
      tmp = tmp & numToChar(xor2(123, c))
    end if
  end repeat
  return tmp
end

on update me
  if mpref.userid = mpref.status.userid then
    nothing()
  end if
end

on getskin me
  return me.mpref.skin
end

on setskin me, path
  me.mpref.skin = path
end

on getsound me
  return 0
end

on setsound me, flag
  me.mpref.sound = flag
end
